<template>
    <div>
        <!--引用表格-->
        <BasicTable @register="registerTable" :rowSelection="rowSelection">
            <!-- 行业分类 -->
            <template #form-suspect="{ model, field }">
                <a-select v-model:value="model[field]" placeholder="请选择行业分类" :fieldNames="{ label: 'text', value: 'value' }"
                    :options="isSuspectOptions" @change="changeSuspect"></a-select>
            </template>
            <template #form-category="{ model, field }">
                <a-tree-select v-model:value="model[field]" show-search placeholder="请选择二级" allow-clear
                    tree-default-expand-all :field-names="{ label: 'name', value: 'id', children: 'children' }"
                    :tree-data="treeData" tree-node-filter-prop="label">
                    <template #suffixIcon>
                        <SmileOutlined />
                    </template>
                </a-tree-select>
            </template>
            <!--插槽:table标题-->
            <template #tableTitle>
                <!-- <a-button type="primary" @click="handleAdd" v-auth="'qdml-add'">添加</a-button> -->
                <a-button type="primary" @click="handleEdit" v-auth="'qdml-fxgkxfycml-xgzb'">完善信息</a-button>
                <!-- <a-button type="primary" @click="handleView" v-auth="'qdml-view'">查看基本信息</a-button> -->
                <a-button type="primary" @click="edidDK" v-auth="'qdml-fxgkxfycml-xgmc'">修改地块名称</a-button>
                <a-button type="primary" @click="allocat" v-auth="'qdml-fxgkxfycml-zhfp'">账号分配</a-button>
                <!-- <a-popconfirm title="是否确认删除?" ok-text="是" cancel-text="否" @confirm="del">
                    <a href="#"> <a-button type="primary" v-auth="'qdml-del'">删除</a-button></a>
                </a-popconfirm> -->
                <!-- <a-button type="primary" @click="move" v-auth="'qdml-gz'">移入预关注</a-button> -->
                <a-button type="primary" @click="midify" v-auth="'qdml-fxgkxfycml-xgzb'">修改坐标</a-button>
            </template>
            <!--操作栏-->
            <!-- <template #action="{ record }">
                <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
            </template> -->
        </BasicTable>

        <!-- 表单区域 -->
        <GWrdkjbxxbModal @register="registerModal" @success="handleSuccess"></GWrdkjbxxbModal>
        <!-- 点击删除的弹框 -->
        <DelModal @register="registerDelModal" @success="handleSuccess"></DelModal>

        <EditDKModal @register="registerEditdkModal" @success="handleSuccess" />
        <!-- 修改坐标 -->
        <ModifyModal @register="registerModifyModal" @success="handleSuccess" />
        <!-- 移入关注 -->
        <MoveinModal @register="registerMoveModal" @success="handleSuccess" />
        <!-- <a-modal v-model:visible="open" :centered="true" title="信息">
      <template #footer>
        <a-button key="submit" type="primary" @click="open = false">确定</a-button>
      </template>
      <div class="py-10 ml-6">该地块还未进行填报，没有详情可以查看</div>
    </a-modal> -->
    </div>
</template>
    
<script lang="ts" name="dkgl-mlqd" setup>
import { ref, computed, unref } from 'vue';
// import { SmileOutlined } from '@ant-design/icons-vue';
import { BasicTable, useTable, TableAction } from '/@/components/Table';
import { useModal } from '/@/components/Modal';
import { useListPage } from '/@/hooks/system/useListPage'
import mlqdMoadl from './modules/mlqdModal.vue'
import { columns, searchFormSchema } from './data';
import { list, deleteOne, batchDelete, getImportUrl, getExportUrl } from './api';
//   import { getTown, categoryList, dict } from '/@/api/common/api'
import { useCategoryData, useSuspectsData } from '/@/utils/domUtils';
import GWrdkjbxxbModal from '../components/GWrdkjbxxbModal.vue'
import EditDKModal from '../components/EditDKModal.vue'
import ModifyModal from '../components/ModifyModal.vue'
import MoveinModal from '../components/MoveinModal.vue'
import DelModal from '../components/DelModal.vue'
import { allocation } from '../components/GWrdkjbxxb.api';
import { useMessage } from '/@/hooks/web/useMessage';
import { useRouter } from 'vue-router';
const { createMessage } = useMessage();

//注册model
const [registerModal, { openModal }] = useModal();
const [registerDelModal, { openModal: openDelModal }] = useModal();
const [registerEditdkModal, { openModal: openEditdkModal }] = useModal();
const [registerModifyModal, { openModal: openModifyModal }] = useModal();
const [registerMoveModal, { openModal: openMoveModal }] = useModal();
//注册table数据
const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
        title: '移除调查名录清单',
        api: list,
        columns,
        canResize: false,
        clickToRowSelect: true,
        rowSelection: { type: 'radio', },
        rowKey: "wrdkid",
        formConfig: {
            labelWidth: 120,
            schemas: searchFormSchema,
            autoSubmitOnEnter: true,
            showAdvancedButton: false,
            autoAdvancedCol: 20 //超过几行显示折叠默认是3
        },
        showActionColumn:false,
        // actionColumn: {
        //     width: 120,
        // },
    },
    exportConfig: {
        name: "污染地块基本信息",
        url: getExportUrl,
    },
    importConfig: {
        url: getImportUrl
    },
})

const [registerTable, { reload }, { rowSelection, selectedRows, selectedRowKeys }] = tableContext

const isSuspectOptions = useSuspectsData().data; // 行业分类
const useCategory = useCategoryData();
const treeData = useCategory.data; // 行业类别-数据
const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
/**
 * 新增事件
 */
function handleAdd() {
    openModal(true, {
        isUpdate: false,
        showFooter: true,

    });
}
// 修改地块名称
function edidDK() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，每次只能选中一条');
        return
    }
    openEditdkModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
    });
}
// 点击账号分配
async function allocat() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，每次只能选中一条');
        return
    }
    await allocation({ wrdkid: selectedRowKeys.value[0] })

}
// 修改坐标
function midify() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，每次只能选中一条');
        return
    }
    openModifyModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
    });
}
//  删除
async function del() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，每次只能选中一条');
        return
    }
    openDelModal(
        true,
        {
            record: selectedRows.value[0],
            isUpdate: true,
            showFooter: true,
        });
    // await deleteOne({ id: selectedRowKeys.value[0] }, reload);
}
/**
 * 编辑事件
 */
function handleEdit() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择要修改的地块');
        return
    }
    openModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
    });
}
// 移入关注
function move() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择要移入关注的数据');
        return
    }
    openMoveModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
    });
}
/**
 * 详情
*/
let router = useRouter();
function handleView() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，每次只能选中一条');
        return
    }
    const record: any = selectedRows.value[0]
    if (!record.dclx) {
        open.value = true
        return
    }
    router.push(`/directory/mlzk/land/modules/ViewModal?wrdkid=${record.wrdkid}`)
}


/**
 * 成功回调
 */
function handleSuccess() {
    selectedRows.value = []
    selectedRowKeys.value = []
    reload();
}
</script>
<style scoped></style>